// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_radar_msgs:msg/ObjectB.idl
// generated code does not contain a copyright notice
#include "off_highway_radar_msgs/msg/detail/object_b__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
off_highway_radar_msgs__msg__ObjectB__init(off_highway_radar_msgs__msg__ObjectB * msg)
{
  if (!msg) {
    return false;
  }
  // can_id
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    off_highway_radar_msgs__msg__ObjectB__fini(msg);
    return false;
  }
  // id
  // time_since_meas
  // zone
  // rcs
  // moving
  // near
  // exist_probability
  return true;
}

void
off_highway_radar_msgs__msg__ObjectB__fini(off_highway_radar_msgs__msg__ObjectB * msg)
{
  if (!msg) {
    return;
  }
  // can_id
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // id
  // time_since_meas
  // zone
  // rcs
  // moving
  // near
  // exist_probability
}

bool
off_highway_radar_msgs__msg__ObjectB__are_equal(const off_highway_radar_msgs__msg__ObjectB * lhs, const off_highway_radar_msgs__msg__ObjectB * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // can_id
  if (lhs->can_id != rhs->can_id) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // time_since_meas
  if (lhs->time_since_meas != rhs->time_since_meas) {
    return false;
  }
  // zone
  if (lhs->zone != rhs->zone) {
    return false;
  }
  // rcs
  if (lhs->rcs != rhs->rcs) {
    return false;
  }
  // moving
  if (lhs->moving != rhs->moving) {
    return false;
  }
  // near
  if (lhs->near != rhs->near) {
    return false;
  }
  // exist_probability
  if (lhs->exist_probability != rhs->exist_probability) {
    return false;
  }
  return true;
}

bool
off_highway_radar_msgs__msg__ObjectB__copy(
  const off_highway_radar_msgs__msg__ObjectB * input,
  off_highway_radar_msgs__msg__ObjectB * output)
{
  if (!input || !output) {
    return false;
  }
  // can_id
  output->can_id = input->can_id;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // time_since_meas
  output->time_since_meas = input->time_since_meas;
  // zone
  output->zone = input->zone;
  // rcs
  output->rcs = input->rcs;
  // moving
  output->moving = input->moving;
  // near
  output->near = input->near;
  // exist_probability
  output->exist_probability = input->exist_probability;
  return true;
}

off_highway_radar_msgs__msg__ObjectB *
off_highway_radar_msgs__msg__ObjectB__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_radar_msgs__msg__ObjectB * msg = (off_highway_radar_msgs__msg__ObjectB *)allocator.allocate(sizeof(off_highway_radar_msgs__msg__ObjectB), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_radar_msgs__msg__ObjectB));
  bool success = off_highway_radar_msgs__msg__ObjectB__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_radar_msgs__msg__ObjectB__destroy(off_highway_radar_msgs__msg__ObjectB * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_radar_msgs__msg__ObjectB__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_radar_msgs__msg__ObjectB__Sequence__init(off_highway_radar_msgs__msg__ObjectB__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_radar_msgs__msg__ObjectB * data = NULL;

  if (size) {
    data = (off_highway_radar_msgs__msg__ObjectB *)allocator.zero_allocate(size, sizeof(off_highway_radar_msgs__msg__ObjectB), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_radar_msgs__msg__ObjectB__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_radar_msgs__msg__ObjectB__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_radar_msgs__msg__ObjectB__Sequence__fini(off_highway_radar_msgs__msg__ObjectB__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_radar_msgs__msg__ObjectB__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_radar_msgs__msg__ObjectB__Sequence *
off_highway_radar_msgs__msg__ObjectB__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_radar_msgs__msg__ObjectB__Sequence * array = (off_highway_radar_msgs__msg__ObjectB__Sequence *)allocator.allocate(sizeof(off_highway_radar_msgs__msg__ObjectB__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_radar_msgs__msg__ObjectB__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_radar_msgs__msg__ObjectB__Sequence__destroy(off_highway_radar_msgs__msg__ObjectB__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_radar_msgs__msg__ObjectB__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_radar_msgs__msg__ObjectB__Sequence__are_equal(const off_highway_radar_msgs__msg__ObjectB__Sequence * lhs, const off_highway_radar_msgs__msg__ObjectB__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_radar_msgs__msg__ObjectB__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_radar_msgs__msg__ObjectB__Sequence__copy(
  const off_highway_radar_msgs__msg__ObjectB__Sequence * input,
  off_highway_radar_msgs__msg__ObjectB__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_radar_msgs__msg__ObjectB);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_radar_msgs__msg__ObjectB * data =
      (off_highway_radar_msgs__msg__ObjectB *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_radar_msgs__msg__ObjectB__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_radar_msgs__msg__ObjectB__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_radar_msgs__msg__ObjectB__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
