// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_radar_msgs:msg/ObjectB.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__TRAITS_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_radar_msgs/msg/detail/object_b__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace off_highway_radar_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectB & msg,
  std::ostream & out)
{
  out << "{";
  // member: can_id
  {
    out << "can_id: ";
    rosidl_generator_traits::value_to_yaml(msg.can_id, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: time_since_meas
  {
    out << "time_since_meas: ";
    rosidl_generator_traits::value_to_yaml(msg.time_since_meas, out);
    out << ", ";
  }

  // member: zone
  {
    out << "zone: ";
    rosidl_generator_traits::value_to_yaml(msg.zone, out);
    out << ", ";
  }

  // member: rcs
  {
    out << "rcs: ";
    rosidl_generator_traits::value_to_yaml(msg.rcs, out);
    out << ", ";
  }

  // member: moving
  {
    out << "moving: ";
    rosidl_generator_traits::value_to_yaml(msg.moving, out);
    out << ", ";
  }

  // member: near
  {
    out << "near: ";
    rosidl_generator_traits::value_to_yaml(msg.near, out);
    out << ", ";
  }

  // member: exist_probability
  {
    out << "exist_probability: ";
    rosidl_generator_traits::value_to_yaml(msg.exist_probability, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectB & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: can_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "can_id: ";
    rosidl_generator_traits::value_to_yaml(msg.can_id, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: time_since_meas
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_since_meas: ";
    rosidl_generator_traits::value_to_yaml(msg.time_since_meas, out);
    out << "\n";
  }

  // member: zone
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zone: ";
    rosidl_generator_traits::value_to_yaml(msg.zone, out);
    out << "\n";
  }

  // member: rcs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rcs: ";
    rosidl_generator_traits::value_to_yaml(msg.rcs, out);
    out << "\n";
  }

  // member: moving
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "moving: ";
    rosidl_generator_traits::value_to_yaml(msg.moving, out);
    out << "\n";
  }

  // member: near
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "near: ";
    rosidl_generator_traits::value_to_yaml(msg.near, out);
    out << "\n";
  }

  // member: exist_probability
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exist_probability: ";
    rosidl_generator_traits::value_to_yaml(msg.exist_probability, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectB & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_radar_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_radar_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_radar_msgs::msg::ObjectB & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_radar_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_radar_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_radar_msgs::msg::ObjectB & msg)
{
  return off_highway_radar_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_radar_msgs::msg::ObjectB>()
{
  return "off_highway_radar_msgs::msg::ObjectB";
}

template<>
inline const char * name<off_highway_radar_msgs::msg::ObjectB>()
{
  return "off_highway_radar_msgs/msg/ObjectB";
}

template<>
struct has_fixed_size<off_highway_radar_msgs::msg::ObjectB>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<off_highway_radar_msgs::msg::ObjectB>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<off_highway_radar_msgs::msg::ObjectB>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_B__TRAITS_HPP_
