// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_radar_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_radar_msgs/msg/detail/object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'a'
#include "off_highway_radar_msgs/msg/detail/object_a__traits.hpp"
// Member 'b'
#include "off_highway_radar_msgs/msg/detail/object_b__traits.hpp"

namespace off_highway_radar_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Object & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: a
  {
    out << "a: ";
    to_flow_style_yaml(msg.a, out);
    out << ", ";
  }

  // member: b
  {
    out << "b: ";
    to_flow_style_yaml(msg.b, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: a
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "a:\n";
    to_block_style_yaml(msg.a, out, indentation + 2);
  }

  // member: b
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "b:\n";
    to_block_style_yaml(msg.b, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Object & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_radar_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_radar_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_radar_msgs::msg::Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_radar_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_radar_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_radar_msgs::msg::Object & msg)
{
  return off_highway_radar_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_radar_msgs::msg::Object>()
{
  return "off_highway_radar_msgs::msg::Object";
}

template<>
inline const char * name<off_highway_radar_msgs::msg::Object>()
{
  return "off_highway_radar_msgs/msg/Object";
}

template<>
struct has_fixed_size<off_highway_radar_msgs::msg::Object>
  : std::integral_constant<bool, has_fixed_size<off_highway_radar_msgs::msg::ObjectA>::value && has_fixed_size<off_highway_radar_msgs::msg::ObjectB>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_radar_msgs::msg::Object>
  : std::integral_constant<bool, has_bounded_size<off_highway_radar_msgs::msg::ObjectA>::value && has_bounded_size<off_highway_radar_msgs::msg::ObjectB>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_radar_msgs::msg::Object>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
