// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_radar_msgs:msg/ObjectA.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__TRAITS_HPP_
#define OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_radar_msgs/msg/detail/object_a__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__traits.hpp"
// Member 'velocity'
#include "geometry_msgs/msg/detail/twist__traits.hpp"

namespace off_highway_radar_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectA & msg,
  std::ostream & out)
{
  out << "{";
  // member: can_id
  {
    out << "can_id: ";
    rosidl_generator_traits::value_to_yaml(msg.can_id, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: meas
  {
    out << "meas: ";
    rosidl_generator_traits::value_to_yaml(msg.meas, out);
    out << ", ";
  }

  // member: valid
  {
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << ", ";
  }

  // member: hist
  {
    out << "hist: ";
    rosidl_generator_traits::value_to_yaml(msg.hist, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectA & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: can_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "can_id: ";
    rosidl_generator_traits::value_to_yaml(msg.can_id, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }

  // member: meas
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "meas: ";
    rosidl_generator_traits::value_to_yaml(msg.meas, out);
    out << "\n";
  }

  // member: valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << "\n";
  }

  // member: hist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hist: ";
    rosidl_generator_traits::value_to_yaml(msg.hist, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectA & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_radar_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_radar_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_radar_msgs::msg::ObjectA & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_radar_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_radar_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_radar_msgs::msg::ObjectA & msg)
{
  return off_highway_radar_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_radar_msgs::msg::ObjectA>()
{
  return "off_highway_radar_msgs::msg::ObjectA";
}

template<>
inline const char * name<off_highway_radar_msgs::msg::ObjectA>()
{
  return "off_highway_radar_msgs/msg/ObjectA";
}

template<>
struct has_fixed_size<off_highway_radar_msgs::msg::ObjectA>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value && has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<geometry_msgs::msg::Twist>::value> {};

template<>
struct has_bounded_size<off_highway_radar_msgs::msg::ObjectA>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value && has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<geometry_msgs::msg::Twist>::value> {};

template<>
struct is_message<off_highway_radar_msgs::msg::ObjectA>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_RADAR_MSGS__MSG__DETAIL__OBJECT_A__TRAITS_HPP_
